﻿using System.Collections.Generic;
using AltNetSample.Domain;

namespace AltNetSample.Infrastructure
{
    public class Customers : ICustomerRepository
    {
        public void AddCustomer(Customer customer)
        {
            //persist customer in here
        }

        public void AddCustomers(IEnumerable<Customer> customers)
        {
            //persist customers in here
        }

        public void ChangeCustomer(Customer customer)
        {
            //update the custoemr here
        }

        public IEnumerable<Customer> FromState(State state)
        {
            //do some data access in here
            return new List<Customer>();
        }

        public IEnumerable<Customer> OverCreditLimit()
        {
            //do some data access in here
            return new List<Customer>();
        }

        public void RemoveCustomer(Customer customer)
        {
            //delete customer here
        }

        public void RemoveCustomers(IEnumerable<Customer> customers)
        {
            //delete customers here
        }

        public IEnumerable<Customer> WithOutstandingOrders()
        {
            //real method would have to select from database, set to a new list here so it compiles!
            IList<Customer> customersFromDatabase = new List<Customer>();

            OutstandingOrderConstraint outstandingOrder = new OutstandingOrderConstraint();

            ICollection<Customer> matchingCustomers = new List<Customer>();

            foreach (Customer candidate in customersFromDatabase)
            {
                foreach (Order order in candidate.OrdersNotCancelled)
                {
                    if (outstandingOrder.IsSatisfiedBy(order))
                        matchingCustomers.Add(candidate);
                }

            }

            return matchingCustomers;
        }

    }
}